package it.geosolutions.geofence.gui.client.service;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface GsUsersManagerRemoteServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.GsUsersManagerRemoteService
     */
    void getGsUsers( int offset, int limit, boolean full, AsyncCallback<com.extjs.gxt.ui.client.data.PagingLoadResult<it.geosolutions.geofence.gui.client.model.GSUser>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.GsUsersManagerRemoteService
     */
    void saveGsUser( it.geosolutions.geofence.gui.client.model.GSUser user, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.GsUsersManagerRemoteService
     */
    void deleteGsUser( it.geosolutions.geofence.gui.client.model.GSUser user, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.GsUsersManagerRemoteService
     */
    void getUserLimitsInfo( it.geosolutions.geofence.gui.client.model.GSUser user, AsyncCallback<it.geosolutions.geofence.gui.client.model.data.UserLimitsInfo> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.GsUsersManagerRemoteService
     */
    void saveUserLimitsInfo( it.geosolutions.geofence.gui.client.model.data.UserLimitsInfo userLimitInfo, AsyncCallback<it.geosolutions.geofence.gui.client.model.data.UserLimitsInfo> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static GsUsersManagerRemoteServiceAsync instance;

        public static final GsUsersManagerRemoteServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (GsUsersManagerRemoteServiceAsync) GWT.create( GsUsersManagerRemoteService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "GsUsersManagerRemoteService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
