package it.geosolutions.geofence.gui.client.service;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface LoginRemoteServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.LoginRemoteService
     */
    void authenticate( java.lang.String userName, java.lang.String password, AsyncCallback<it.geosolutions.geofence.gui.client.model.User> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.LoginRemoteService
     */
    void logout( AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.LoginRemoteService
     */
    void isAuthenticated( AsyncCallback<java.lang.Boolean> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static LoginRemoteServiceAsync instance;

        public static final LoginRemoteServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (LoginRemoteServiceAsync) GWT.create( LoginRemoteService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "LoginRemoteService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
