package it.geosolutions.geofence.gui.client.service;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface RulesManagerRemoteServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void getRules( int offset, int limit, boolean full, AsyncCallback<com.extjs.gxt.ui.client.data.PagingLoadResult<it.geosolutions.geofence.gui.client.model.Rule>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void saveRule( it.geosolutions.geofence.gui.client.model.Rule rules, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void deleteRule( it.geosolutions.geofence.gui.client.model.Rule rules, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void findRule( it.geosolutions.geofence.gui.client.model.Rule rules, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void shift( long priorityStart, long offset, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void swap( long id1, long id2, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void saveAllRules( java.util.List<it.geosolutions.geofence.gui.client.model.Rule> rules, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void setDetailsProps( java.lang.Long ruleId, java.util.List<it.geosolutions.geofence.gui.client.model.data.LayerCustomProps> customProps, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void getLayerAttributes( it.geosolutions.geofence.gui.client.model.Rule rule, AsyncCallback<java.util.List<it.geosolutions.geofence.gui.client.model.data.LayerAttribUI>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void setLayerAttributes( java.lang.Long ruleId, java.util.List<it.geosolutions.geofence.gui.client.model.data.LayerAttribUI> layerAttributes, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void saveLayerDetailsInfo( it.geosolutions.geofence.gui.client.model.data.LayerDetailsInfo layerDetailsForm, java.util.List<it.geosolutions.geofence.gui.client.model.data.LayerStyle> layerStyles, AsyncCallback<it.geosolutions.geofence.gui.client.model.data.LayerDetailsInfo> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void getLayerDetailsInfo( it.geosolutions.geofence.gui.client.model.Rule rule, AsyncCallback<it.geosolutions.geofence.gui.client.model.data.LayerDetailsInfo> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void saveLayerLimitsInfo( it.geosolutions.geofence.gui.client.model.data.LayerLimitsInfo layerLimitsForm, AsyncCallback<it.geosolutions.geofence.gui.client.model.data.LayerLimitsInfo> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.RulesManagerRemoteService
     */
    void getLayerLimitsInfo( it.geosolutions.geofence.gui.client.model.Rule rule, AsyncCallback<it.geosolutions.geofence.gui.client.model.data.LayerLimitsInfo> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static RulesManagerRemoteServiceAsync instance;

        public static final RulesManagerRemoteServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (RulesManagerRemoteServiceAsync) GWT.create( RulesManagerRemoteService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "RulesManagerRemoteService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
