package it.geosolutions.geofence.gui.client.service;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ProfilesManagerRemoteServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.ProfilesManagerRemoteService
     */
    void getProfiles( int offset, int limit, boolean full, AsyncCallback<com.extjs.gxt.ui.client.data.PagingLoadResult<it.geosolutions.geofence.gui.client.model.UserGroup>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.ProfilesManagerRemoteService
     */
    void saveProfile( it.geosolutions.geofence.gui.client.model.UserGroup profile, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.ProfilesManagerRemoteService
     */
    void deleteProfile( it.geosolutions.geofence.gui.client.model.UserGroup profile, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.ProfilesManagerRemoteService
     */
    void getProfileCustomProps( int offset, int limit, it.geosolutions.geofence.gui.client.model.UserGroup profile, AsyncCallback<com.extjs.gxt.ui.client.data.PagingLoadResult<it.geosolutions.geofence.gui.client.model.data.ProfileCustomProps>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.ProfilesManagerRemoteService
     */
    void setProfileProps( java.lang.Long profileId, java.util.List<it.geosolutions.geofence.gui.client.model.data.ProfileCustomProps> customProps, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ProfilesManagerRemoteServiceAsync instance;

        public static final ProfilesManagerRemoteServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ProfilesManagerRemoteServiceAsync) GWT.create( ProfilesManagerRemoteService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ProfilesManagerRemoteService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
